Bug 233751 - BSD_CRTBEGIN does not work on powerpc
Summary: BSD_CRTBEGIN does not work on powerpc
Status: Closed FIXED
Alias: None
Product: Base System
Classification: Unclassified
Component: bin (show other bugs)
Version: CURRENT
Hardware: powerpc Any
: --- Affects Only Me
Assignee: Justin Hibbits
URL:
Keywords:
Depends on:
Blocks: 228919 233094
  Show dependency treegraph
 
Reported: 2018-12-03 14:28 UTC by Ed Maste
Modified: 2019-09-16 19:25 UTC (History)
3 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ed Maste freebsd_committer 2018-12-03 14:28:48 UTC
See https://lists.freebsd.org/pipermail/svn-src-all/2018-December/173249.html

> /usr/bin/ld: crtsavres.o: No such file: No such file or directory

andrew@ has disabled BSD_CRTBEGIN on powerpc in r341424
Comment 1 Mark Millard 2018-12-04 05:06:45 UTC
Why did https://ci.freebsd.org/job/FreeBSD-head-powerpc64-build/8288/
and https://ci.freebsd.org/job/FreeBSD-head-powerpc-build/8576/
(Nov 23) and various later not show failures from the change?

Had the builds been using old crtsavres.o files from prior builds?
(If so, such does not seem to be a good property of the build
environment.)
Comment 2 Mark Millard 2018-12-04 05:21:47 UTC
(In reply to Mark Millard from comment #1)

I wonder if it is a race condition instead of just-missing
file.

Looking at the build logs I see things like:

--- crtsavres.o ---
. . . 
--- crtsavres.o ---
cc --sysroot=/usr/obj/usr/src/powerpc.powerpc/tmp -B/usr/obj/usr/src/powerpc.powerpc/tmp/usr/bin -x assembler-with-cpp -O2 -pipe   -DIN_GCC -DHAVE_LD_EH_FRAME_HDR -DDT_CONFIG -D__GLIBC__=3 -fno-inline-functions -fno-exceptions  -fno-zero-initialized-in-bss -fno-asynchronous-unwind-tables  -fno-omit-frame-pointer -I/usr/src/contrib/gcclibs/include -I/usr/src/contrib/gcc/config -I/usr/src/contrib/gcc -I.  -I/usr/src/gnu/usr.bin/cc/cc_tools -g  -std=gnu89    -finhibit-size-directive -fno-toplevel-reorder    -c /usr/src/contrib/gcc/config/rs6000/crtsavres.asm  -o crtsavres.o

and:

-- crtsavres.o ---
. . .
--- crtsavres.o ---
cc --sysroot=/usr/obj/usr/src/powerpc.powerpc64/tmp -B/usr/obj/usr/src/powerpc.powerpc64/tmp/usr/bin -x assembler-with-cpp -O2 -pipe   -DIN_GCC -DHAVE_LD_EH_FRAME_HDR -DDT_CONFIG -D__GLIBC__=3 -fno-inline-functions -fno-exceptions  -fno-zero-initialized-in-bss -fno-asynchronous-unwind-tables  -fno-omit-frame-pointer -I/usr/src/contrib/gcclibs/include -I/usr/src/contrib/gcc/config -I/usr/src/contrib/gcc -I.  -I/usr/src/gnu/usr.bin/cc/cc_tools -g  -std=gnu89    -finhibit-size-directive -fno-toplevel-reorder    -c /usr/src/contrib/gcc/config/rs6000/crtsavres.asm  -o crtsavres.o
Comment 3 Mark Millard 2018-12-04 07:47:19 UTC
(In reply to Mark Millard from comment #2)

This may be a duplicate of bugzilla 233733 .
Comment 4 Ed Maste freebsd_committer 2018-12-04 14:25:26 UTC
(In reply to Mark Millard from comment #3)
There is a race condition as well but this PR is not a duplicate -- once PR233733 is fixed powerpc with BSD_CRTBEGIN should consistently fail due to missing crtsavres.o.
Comment 5 Justin Hibbits freebsd_committer 2019-01-12 05:08:32 UTC
Review available at https://reviews.freebsd.org/D18826
Comment 6 commit-hook freebsd_committer 2019-01-12 21:30:30 UTC
A commit references this bug:

Author: jhibbits
Date: Sat Jan 12 21:29:55 UTC 2019
New revision: 342974
URL: https://svnweb.freebsd.org/changeset/base/342974

Log:
  Create crtsavres.o for powerpc builds

  Summary:
  GCC expects to link in a crtsavres.o on powerpc platforms.  On
  powerpc64 this is an empty file, but on powerpc and powerpcspe this does contain
  some save/restore functions, which may not actually be necessary for newer
  modern GCC and clang.  This appeases the in-tree gcc, though, and is needed in
  order to switch to the BSD CRTRBEGIN.

  PR:	233751
  Reviewed By: andrew
  Differential Revision: https://reviews.freebsd.org/D18826

Changes:
  head/gnu/lib/csu/Makefile
  head/lib/csu/powerpc/Makefile
  head/lib/csu/powerpc/crtsavres.S
  head/lib/csu/powerpc64/Makefile
Comment 7 Andrew Turner freebsd_committer 2019-08-14 14:35:14 UTC
This should be fixed by so I've enabled BSD_CRTBEGIN in base r351027
Comment 8 commit-hook freebsd_committer 2019-09-16 13:42:03 UTC
A commit references this bug:

Author: andrew
Date: Mon Sep 16 13:41:31 UTC 2019
New revision: 352394
URL: https://svnweb.freebsd.org/changeset/base/352394

Log:
  MFC r339738, r339744, r339770, r339773, r339864-r339866, r339907-r339908, r339912-r339913, r339916, r339954, r340213, r340395, r340840, r340910-r340911, r341424, r342773, r342974, r351027, r352073:

  MFC the BSD crtbegin to stable/12 but keep it disabled.

  r339738:
  Implement a BSD licensed crtbegin/crtend

  These are needed for .ctors/.dtors and .jcr handling. The former needs
  all the function pointers to be called in the correct order from the
  .init/.fini section. The latter just needs to call a gcj specific function
  if it exists with a pointer to the start of the .jcr section.

  This is currently disabled until __dso_handle support is added.

  Reviewed by:	emaste
  Sponsored by:	DARPA, AFRL
  Differential Revision:	https://reviews.freebsd.org/D17587

  r339744:
  Add a missing include for src.opts.mk. Without it MK_TESTS isn't defined.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339770:
  Drop the csu tests WARNS to 5 to fix the powerpc64 build.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339773:
  Add __dso_handle to the BSD crtbegin. This is used to identify shared
  objects.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339864:
  Check __dso_handle is NULL in non-DSO objects. It should only be non-NULL
  when accessed from a shared object.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339865:
  Include the csu test directories in BSD.tests.dist

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339866:
  Make the .ctors, .dtors, and .jcr markers as static. They shouldn't be
  accessible from out of the files they are defined in.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339907:
  The jcr argument to _Jv_RegisterClasses is used, stop marking it otherwise.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339908:
  Run the csu tests on a DSO. This builds the tests into a shared library,
  then runs these from the base test programs. With this we can check
  crtbeginS.o and crtendS.o are working as expected.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339912:
  Fix the location of the static keyword.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339913:
  Disable the .preinit_array test in DSOs, ld.bfd fails to link objects with
  the section.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339916:
  Build the csu tests on all architectures.

  The tests haven't been run them, but this is enough to build them so I can
  get feedback on if the various crt.h headers are correct.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r339954:
  Add __used to __CTOR_LIST__ and __DTOR_LIST__

  Enabling BSD_CRTBEGIN on amd64 resulted in
  error: unused variable '__CTOR_LIST__'.

  __CTOR_LIST__ is indeed unused in crtbegin.c; it marks the beginning of
  the .ctors array and is used in crtend.c.  Annotate __DTOR_LIST__ as
  well for consistency.

  Discussed with:	andrew
  MFC with:	r339738
  Sponsored by:	The FreeBSD Foundation

  r340213:
  Add the (untested) mips and sparc64 .init call sequences.

  The BSD crtbegin/crtend code now builds on all architectures, however
  further work is needed to check if it works correctly.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r340395:
  Run __cxa_finalize in shared objects in the destructor path.

  When we have .dtors call them before .dtor handling, otherwise call from
  a destructor.

  PR:		233056
  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r340840:
  Mark the function called by the MIPS .init/.fini sequence with .local.

  As with r328939 we need to mark local symbols as such. Without this the
  assembly parser treats the symbols as global and created relocations
  against these private symbols.

  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r340910:
  Add the missing 0 at the end of the .jcr section.

  Without this the dynamic library test was failing as it was calling
  _Jv_RegisterClasses multiple times.

  r340911:
  Re-enable the dynamiclib tests. These should be fixed by r340910.

  r341424:
  Disable the BSD CRT code on powerpc and sparc64, they need extra crt*.o
  files that haven't been implemented.

  Reported by:	sbruno
  MFC with:	r339738
  Sponsored by:	DARPA, AFRL

  r342773:
  Add explicit csu test dependency

  lib/csu/tests/dynamiclib requires libh_csu.so be built first.  I'm not
  sure this is the most correct/best way to address this but it solves
  the issue in my testing.

  PR:		233734
  Sponsored by:	The FreeBSD Foundation

  r342974:
  Create crtsavres.o for powerpc builds

  Summary:
  GCC expects to link in a crtsavres.o on powerpc platforms.  On
  powerpc64 this is an empty file, but on powerpc and powerpcspe this does contain
  some save/restore functions, which may not actually be necessary for newer
  modern GCC and clang.  This appeases the in-tree gcc, though, and is needed in
  order to switch to the BSD CRTRBEGIN.

  PR:	233751
  Reviewed By: andrew
  Differential Revision: https://reviews.freebsd.org/D18826

  r351027:
  Enable BSD_CRTBEGIN on powerpc

  In r342974 jhibbits added support to build crtsavres.o. This was the
  blocker for BSD_CRTBEGIN to be enabled there. As such enable this
  option again.

  Reviewed by:	jhibbits
  Sponsored by:	DARPA, AFRL

  r352073:
  csu: Add the riscv .init call sequence

  Reviewed by:	br
  Sponsored by:	Axiado
  Differential Revision:	https://reviews.freebsd.org/D21537

Changes:
_U  stable/12/
  stable/12/etc/mtree/BSD.tests.dist
  stable/12/gnu/lib/Makefile
  stable/12/gnu/lib/csu/Makefile
  stable/12/lib/csu/Makefile
  stable/12/lib/csu/Makefile.inc
  stable/12/lib/csu/aarch64/crt.h
  stable/12/lib/csu/amd64/crt.h
  stable/12/lib/csu/arm/crt.h
  stable/12/lib/csu/common/crtbegin.c
  stable/12/lib/csu/common/crtend.c
  stable/12/lib/csu/i386/crt.h
  stable/12/lib/csu/mips/crt.h
  stable/12/lib/csu/powerpc/Makefile
  stable/12/lib/csu/powerpc/crt.h
  stable/12/lib/csu/powerpc/crtsavres.S
  stable/12/lib/csu/powerpc64/Makefile
  stable/12/lib/csu/powerpc64/crt.h
  stable/12/lib/csu/riscv/crt.h
  stable/12/lib/csu/sparc64/crt.h
  stable/12/lib/csu/tests/
  stable/12/lib/csu/tests/Makefile
  stable/12/lib/csu/tests/Makefile.tests
  stable/12/lib/csu/tests/cxx_constructors.cc
  stable/12/lib/csu/tests/dso/
  stable/12/lib/csu/tests/dynamic/Makefile
  stable/12/lib/csu/tests/dynamiclib/
  stable/12/lib/csu/tests/fini_test.c
  stable/12/lib/csu/tests/init_test.c
  stable/12/lib/csu/tests/static/Makefile
  stable/12/share/mk/src.opts.mk
  stable/12/tools/build/options/WITHOUT_BSD_CRTBEGIN
  stable/12/tools/build/options/WITH_BSD_CRTBEGIN